<?php
    /* 
    ============================================================================
    this page manages entries to a liveticker.
    ============================================================================
    Author: Martin Widmann, martin.widmann@ideefix.net
    Version: 1.0
    */
    require('../config.php');
    require('../db_functions.php');
    require('../file_functions.php');
    
    $entry_id           = 0;

    $id = $_REQUEST["id"];
    $entry_id = $_REQUEST["entry_id"];
    $action = $_REQUEST["todoaction"];
    $showall = $_REQUEST["showall"];
    $home_name = $_REQUEST["home_name"];
    $away_name = $_REQUEST["away_name"];
    $smin = $_REQUEST["smin"];
    $ssec = $_REQUEST["ssec"];
    
    $entry_type         = 0; // 0: info, 1: goal, 2: penalty
    $team               = 2; // 0: home, 1: away, 2: no team
    $playtime_min       = "00"; // the playtime
    $playtime_sec       = "00";
    $player1            = ""; // the 1st player involved. 
    $player2            = ""; // 1st assist player
    $player3            = ""; // 2nd assist player
    $powerplay          = 0; // 0: no powerplay, 1: PP1, 2: PP2, 3: SH1, 4: SH2
    $penalty_time       = 2; // 
    $penalty_reason     = "";
    $penalty_extension  = 0; // 0: no extension, 1: +2, 2: +10, 3: match, 4: game
    $info               = "";
    
    if ($smin) $playtime_min = $smin;
    if ($ssec) $playtime_sec = $ssec;
    
    $players_home = loadContent(OUTPUTDIR . "/players_home_" . $id);
    $players_away = loadContent(OUTPUTDIR . "/players_away_" . $id);
    
    if ($action == 'store') {
        $entry_type         = $_POST["entry_type"];
        $team               = $_POST["team"];
        $playtime_min       = normalize($_POST["playtime_min"]);
        $playtime_sec       = normalize($_POST["playtime_sec"]);
        $player1            = $conn->escape($_POST["player1"]);
        $player2            = $conn->escape($_POST["player2"]);
        $player3            = $conn->escape($_POST["player3"]);
        $powerplay          = $_POST["powerplay"];
        $penalty_time       = $_POST["penalty_time"];
        $penalty_reason     = $conn->escape($_POST["penalty_reason"]);
        $penalty_extension  = $_POST["penalty_extension"];
        $info               = $conn->escape($_POST["info"]);
        
        $playtime = $playtime_min . ":" . $playtime_sec;
        // create a new entry
        if ($entry_id == 0) {
            
            $sql = 
                "INSERT INTO    liveticker_entry " .
                "               (" .
                "               match_id, entry_type, team, playtime, player1, ".
                "               player2, player3, powerplay, penalty_time, ".
                "               penalty_reason, penalty_extension, info, entry_time" .
                "               ) " .
                "VALUES         ($id, $entry_type, $team, " .
                "               '$playtime', " .
                "               '$player1', '$player2', '$player3', $powerplay, " .
                "               $penalty_time, '$penalty_reason', " .
                "               $penalty_extension, '$info', now())" ;
            
            $conn->query($sql);
            $smin = $playtime_min;
            $ssec = $playtime_sec;    
          
        } 
        
        // update a given entry
        else {
            
            $sql =
                "UPDATE         liveticker_entry " .
                "SET            entry_type = $entry_type, " .
                "               team = $team, " .
                "               playtime = '$playtime', " .
                "               player1 = '$player1', " .
                "               player2 = '$player2', " .
                "               player3 = '$player3', " .
                "               powerplay = $powerplay, " .
                "               penalty_time = $penalty_time, " .
                "               penalty_reason = '$penalty_reason', " .
                "               penalty_extension = $penalty_extension, " .
                "               info = '$info' " .
                "WHERE          entry_id = $entry_id";
            
            $conn->query($sql);
        }
        
        callForUpdate($id);

        // redirect to self
        $host  = $_SERVER['HTTP_HOST'];
        $uri  = rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
        $extra = 'liveticker.php?id=' . $id . '&home_name=' . $home_name . '&away_name=' . $away_name . '&smin=' . $smin . '&ssec=' . $ssec;
        header("Location: http://$host$uri/$extra");
        exit;           

    }
    
    // load an entry
    else if ($action == 'edit') {
        
        $sql = 
            "SELECT     * " .
            "FROM       liveticker_entry " .
            "WHERE      entry_id = $entry_id"; 
        
        $conn->query($sql);
        if ($conn->query($sql) > 0) {
                
            $row = $conn->resultRows[0];
            $entry_type         = $row->entry_type;
            $team               = $row->team;
            $playtime           = $row->playtime;
            $player1            = $conn->unescape($row->player1);
            $player2            = $conn->unescape($row->player2);
            $player3            = $conn->unescape($row->player3);
            $powerplay          = $row->powerplay;
            $penalty_time       = $row->penalty_time;
            $penalty_reason     = $conn->unescape($row->penalty_reason);
            $penalty_extension  = $row->penalty_extension;
            $info               = $conn->unescape($row->info);
            
            list ($playtime_min, $playtime_sec) = split(":", $playtime);
        }
        
    }
    
    // delete an entry
    else if ($action == 'delete') {
        $sql = "DELETE FROM liveticker_entry WHERE entry_id = $entry_id";
        
        $conn->query($sql);
        $entry_id = 0;
        callForUpdate($id);
    }
    
    
    function normalize($text) {
        if (strlen($text) == 1) {
            $text = "0" . $text;
        }
        if (is_numeric($text)) {
            return $text;
        } else {
            return "00";
        }
    }
    
    function callForUpdate($id) {
        touch(OUTPUTDIR . "/update_$id");
    }
    
?>

<html>
    <head>
        <title>Liveticker verwalten</title>
        <link rel="stylesheet" type="text/css" href="styles.css" />
        
        <script type="text/javascript">
        
            function switchType(type) {
                if (type == 0) {
                    
                    document.getElementById("players").style.display = 'none';
                    document.getElementById("goal_players").style.display = 'none';
                    document.getElementById("goal_type").style.display = 'none';
                    document.getElementById("penalty").style.display = 'none';
                    
                } else if (type == 1) {
                    
                    document.getElementById("players").style.display = 'inline';
                    document.getElementById("goal_players").style.display = 'inline';
                    document.getElementById("goal_type").style.display = 'inline';
                    document.getElementById("penalty").style.display = 'none';
                    
                } else if (type == 2) {
                    
                    document.getElementById("players").style.display = 'inline';
                    document.getElementById("goal_players").style.display = 'none';
                    document.getElementById("goal_type").style.display = 'none';
                    document.getElementById("penalty").style.display = 'inline';

                }
            }
        
            function usePlayer($obj, $field) {
                if ($obj.options[$obj.selectedIndex].value != "")
                    document.form1.elements[$field].value = $obj.options[$obj.selectedIndex].value;
            }
        </script>
    </head>

    <body onLoad="switchType(<?=$entry_type?>);">
        <h1>Liveticker verwalten</h1>
        <form name="form1" action="liveticker.php" method="post">
            <input type="hidden" name="smin" value="<?=$smin?>">
            <input type="hidden" name="ssec" value="<?=$ssec?>">
            <input type="hidden" name="home_name" value="<?=$home_name?>">
            <input type="hidden" name="away_name" value="<?=$away_name?>">
            <input type="hidden" name="id" value="<?=$id?>">
            <input type="hidden" name="todoaction" value="store">
            <input type="hidden" name="entry_id" value="<?=$entry_id?>">
            Eintragstyp:
            <input type="radio" name="entry_type" value="0" <? if ($entry_type == 0) echo("CHECKED") ?> onclick="switchType(0);"> INFO | 
            <input type="radio" name="entry_type" value="1" <? if ($entry_type == 1) echo("CHECKED") ?> onclick="switchType(1);"> TOR | 
            <input type="radio" name="entry_type" value="2" <? if ($entry_type == 2) echo("CHECKED") ?> onclick="switchType(2);"> STRAFE<br>
            Betroffenes Team:
            <input type="radio" name="team" value="2" <? if ($team == 2) echo("CHECKED") ?>> KEINES/BEIDE | 
            <input type="radio" name="team" value="0" <? if ($team == 0) echo("CHECKED") ?>> HEIM (<?=$home_name?>) | 
            <input type="radio" name="team" value="1" <? if ($team == 1) echo("CHECKED") ?>> GAST (<?=$away_name?>)<br>
            Spielzeit: <input type="text" name="playtime_min" value="<?=$playtime_min?>" onfocus="this.select()" size="2">:
            <input type="text" name="playtime_sec" value="<?=$playtime_sec?>" onfocus="this.select()" size="2"><br>
            
            <span id="players">Involvierte Spieler:<br>
            <input type="text" name="player1" value="<?=$player1?>"> <- 
            <select name="listplayer1" onchange="usePlayer(this, 'player1');">
                <option value=""><?=$home_name?></option>
                <?=playerListAsOptions($players_home, $player1);?>
            </select> - 
            <select name="listplayera1" onchange="usePlayer(this, 'player1');">
                <option value=""><?=$away_name?></option>
                <?=playerListAsOptions($players_away, $player1);?>
            </select><br/>
            <span id="goal_players">
            Assist 1: <input type="text" name="player2" value="<?=$player2?>"> <-
            <select name="listplayer2" onchange="usePlayer(this, 'player2');">
                <option value=""><?=$home_name?></option>
                <?=playerListAsOptions($players_home, $player2);?>
            </select> - 
            <select name="listplayera2" onchange="usePlayer(this, 'player2');">
                <option value=""><?=$away_name?></option>
                <?=playerListAsOptions($players_away, $player2);?>
            </select><br/>
            Assist 2: <input type="text" name="player3" value="<?=$player3?>"> <-
            <select name="listplayer3" onchange="usePlayer(this, 'player3');">
                <option value=""><?=$home_name?></option>
                <?=playerListAsOptions($players_home, $player3);?>
            </select> - 
            <select name="listplayera3" onchange="usePlayer(this, 'player3');">
                <option value=""><?=$away_name?></option>
                <?=playerListAsOptions($players_away, $player3);?>
            </select><br/>
            </span><br></span>
            <span id="goal_type">Powerplaytor: 
            <input type="radio" name="powerplay" value="4" <?if ($powerplay == 4) echo("CHECKED") ?>> SH2 |
            <input type="radio" name="powerplay" value="3" <?if ($powerplay == 3) echo("CHECKED") ?>> SH1 |
            <input type="radio" name="powerplay" value="0" <?if ($powerplay == 0) echo("CHECKED") ?>> EQ |
            <input type="radio" name="powerplay" value="1" <?if ($powerplay == 1) echo("CHECKED") ?>> PP1 |
            <input type="radio" name="powerplay" value="2" <?if ($powerplay == 2) echo("CHECKED") ?>> PP2<br></span>
            <span id="penalty">Strafe:
            <input type="radio" name="penalty_time" value="0" <?if ($penalty_time == 0) echo("CHECKED") ?>> 0 |
            <input type="radio" name="penalty_time" value="2" <?if ($penalty_time == 2) echo("CHECKED") ?>> 2 |
            <input type="radio" name="penalty_time" value="5" <?if ($penalty_time == 5) echo("CHECKED") ?>> 5 Minuten wegen 
            <input type="text" name="penalty_reason" value="<?=$penalty_reason?>" size="15"> 
            <select name="possible_penalties" onchange="usePlayer(this, 'penalty_reason');">
                <option value=""></a>
                <option value="Bandencheck">Bandencheck (Boarding)</option>
                <option value="Behinderung">Behinderung (Interference)</option>
                <option value="Beinstellen">Beinstellen (Tripping)</option>
                <option value="Check gegen den Kopf">Check gegen den Kopf (Check to Head or Neck Area)</option>
                <option value="Crosscheck">Crosscheck (Cross-Checking)</option>
                <option value="Check von hinten">Check von hinten (Check from behind)</option>
                <option value="Angriff gegen das Knie">Angriff gegen das Knie (Clipping)</option>
                <option value="Kniecheck">Kniecheck (Kneeing)</option>
                <option value="Ellenbogencheck">Ellenbogencheck (Elbowing)</option>
                <option value="Haken">Haken (Hooking)</option>
                <option value="Halten">Halten (Holding)</option>
                <option value="Faustschlag">Faustschlag (Roughing)</option>
                <option value="Hoher Stock">Hoher Stock (High Sticking)</option>
                <option value="Stockstich">Stockstich (Spearing)</option>
                <option value="Stockschlag">Stockschlag (Slashing)</option>
                <option value="Halten des Stockes">Halten des Stockes (Holding the Stick)</option>
                <option value="Penalty">Penalty (Penalty)</option>
                <option value="zu viele Spieler auf dem Eis">zu viele Spieler auf dem Eis (too many Players on Ice)</option>
                <option value="unsportliches Verhalten">unsportliches Verhalten (unsportsman Like)</option>
                <option value="unerlaubter Krperangriff">unerlaubter Krperangriff (Charging)</option>
                <option value="bertriebene Hrte">bertriebene Hrte (Roughing)</option>
                <option value="Kritik am Entscheid">Kritik am Entscheid (Misconduct)</option> 
                <option value="Spielverzgerung">Spielverzgerung (Delaying the Game)</option>   
            </select> - Strafzusatz: 
            <select name="penalty_extension" size="1">
                <option value="0" <?if ($penalty_extension == 0) echo("SELECTED") ?>></option>
                <option value="1" <?if ($penalty_extension == 1) echo("SELECTED") ?>>+2</option>
                <option value="2" <?if ($penalty_extension == 2) echo("SELECTED") ?>>+10</option>
                <option value="3" <?if ($penalty_extension == 3) echo("SELECTED") ?>>match</option>
                <option value="4" <?if ($penalty_extension == 4) echo("SELECTED") ?>>game</option>
            </select><br></span>
            Info:<br>
            <textarea name="info" cols="80" rows="10" wrap=""><?=$info?></textarea><br>
            <input type="submit" value="Speichern"> 
            <input type="button" value="Abbrechen" onclick="document.location.href='liveticker.php?id=<?=$id?>&home_name=<?=$home_name?>&away_name=<?=$away_name?>&smin=<?=$smin?>&ssec=<?=$ssec?>'">
        </form>
        
        <?php if ($showall == "1") { ?>
        <h1>Alle Eintrge zu diesem Spiel (sortiert nach Erstellung)</h1>
        <?php } else { ?>
        <h1>Letzte 10 Eintrge zu diesem Spiel - <a href="liveticker.php?id=<?=$id?>&showall=1&home_name=<?=$home_name?>&away_name=<?=$away_name?>&smin=<?=$smin?>&ssec=<?=$ssec?>">alle zeigen</a></h1>
        <?php } ?>
        <ul>
        <?php
            $sql = 
                "SELECT     entry_id, entry_type, playtime, player1, left(info, 50) AS shortinfo " .
                "FROM       liveticker_entry " .  
                "WHERE      match_id = $id " .
                "ORDER BY   entry_id DESC ";
            if ($showall != "1")
                $sql .= "LIMIT 10";
            
            $conn->query($sql);
            for ($i = 0; $i < $conn->resultCount; $i++) {
                $row = $conn->resultRows[$i];                

                $entry_id       = $row->entry_id;
                $entry_type     = $row->entry_type;
                $playtime       = $row->playtime;
                $player1        = $conn->unescape($row->player1);
                $shortinfo      = $conn->unescape($row->shortinfo);
                if (strlen($shortinfo) == 50) {
                    $shortinfo .= "...";
                }
                
                switch ($entry_type) {
                    case 0:
                        $type = "INFO";
                        break;
                    case 1:
                        $type = "GOAL";
                        break;
                    case 2:
                        $type = "PENALTY";
                        break;
                } 
            ?>
            <li>
                <?=$playtime?> - <?=$type?> - <?=$player1?> - <?=$shortinfo?> - [<a href="liveticker.php?todoaction=edit&entry_id=<?=$entry_id?>&id=<?=$id?>&home_name=<?=$home_name?>&away_name=<?=$away_name?>&smin=<?=$smin?>&ssec=<?=$ssec?>">editieren</a>] - [<a href="liveticker.php?todoaction=delete&entry_id=<?=$entry_id?>&id=<?=$id?>&home_name=<?=$home_name?>&away_name=<?=$away_name?>&smin=<?=$smin?>&ssec=<?=$ssec?>">lschen</a>]
            </li>            
            <?php    

            }
        ?>
        </ul>
        <hr/>
        [<a href="index.php">Zurck zur Matchauswahl</a>]
    </body>
</html>

<?php

    function playerListAsOptions($list, $selectedPlayer) {
        $ret = "";
        $players = preg_split('/[\n\r]+/',$list);
        for ($i = 0; $i < count($players); $i++) {
            list($currplayer, $l) = split(",", $players[$i]);
            $currplayer = trim($currplayer);
            $ret .= "<option value=\"" . $currplayer . "\"";
            if ($currplayer == $selectedPlayer)
                $ret .= " selected";
            $ret .= ">" . $currplayer . "</option>\n";
        }
        return $ret;
    }

?>